int in1 = 12;   //スイッチ=112PIN
int in2 = 11;   //スイッチ2=11PIN
int in3 = 10;   //スイッチ3=10PIN
int in4 = 9;    //スイッチ4=9PIN
int in5 = 8;    //スイッチ5=8PIN

byte servo_id1 = 17;            //サーボID1(右肩横回転)
byte servo_id2 = 18;            //サーボID1(右ヒジ)
int rotate_speed = 200;         //1周移動時間(秒×100)
int position_offset = 0;        //全体の位置の調整(+転車台が時計回り、-反時計回り)
int reverse_offset = 0;         //反対周りのオフセット
int current_position1 = 0;      //サーボ1の以前の位置
int previous_position1 = 1501;     //サーボ1の以前の位置
int current_position2 = 0;      //サーボ1の以前の位置
int previous_position2 = 1501;     //サーボ1の以前の位置

byte torque_on_data[] = {0xFA, 0xAF, 0x01, 0x00, 0x24, 0x01, 0x01, 0x01, 0x24}; //トルクONコマンド
byte position_data[] = {0xFA, 0xAF, 0x01, 0x00, 0x1E, 0x04, 0x01, 0x00, 0x00, 0x64, 0x00, 0x7E};  // ポジションコマンド

void memcpy(byte* buf, byte* data, int n)     // データ転送
{
  int sum = 0;
  for(int i = 0; i < n; i++){
    buf[i] = data[i];
  }
}

void checksum(byte* data, int n)     // チェックサムの設定
{
  int sum = 0;
  for(int i = 2; i < n - 1; i++){
    sum = sum ^ data[i];
  }
  data[ n-1 ] = sum;
}

void move_servo(int servo_id, int previous_position, int current_position)     // サーボ移動
{
    byte data[12];
    int move_position;  
   //今回の移動時間を計算
    int move_speed = short(abs((long) previous_position - (long) current_position) * (long) rotate_speed / 3600);
    memcpy(data, position_data, 12);         //回転データ転送
    if (current_position < previous_position) {      
      move_position = current_position + position_offset + reverse_offset;
    }
    else {
      move_position = current_position + position_offset;
    }
    memcpy(data, position_data, 12);         //回転データ転送
    data[2] = servo_id;
    memcpy(&data[7], &move_position, 2);     //変更位置設定
    memcpy(&data[9], &move_speed, 2);        //移動時間設定
    checksum(data, 12);                      //チェックサム計算
    Serial.write(data,12);               //変更位置まで回転
    
    delay(move_speed*10);                   //回転終了まで待ち
}
    
void setup() {
 // デジタル入力のプルアップ抵抗を有効にする
  pinMode(in1, INPUT_PULLUP);
  pinMode(in2, INPUT_PULLUP);
  pinMode(in3, INPUT_PULLUP);
  pinMode(in4, INPUT_PULLUP);
  pinMode(in5, INPUT_PULLUP);
    
  Serial.begin(115200);                 //115200bpsでポートを開く
  delay(500);                            //0.5秒待つ
  torque_on_data[2] = servo_id1;        //サーボID1
  checksum(torque_on_data, 9);           //チェックサム計算
  Serial.write(torque_on_data,9);       //サーボトルクON
  torque_on_data[2] = servo_id2;        //サーボID2
  checksum(torque_on_data, 9);           //チェックサム計算
  Serial.write(torque_on_data,9);       //サーボトルクON
  delay(500);                            //0.5秒待つ
  current_position1 = 600;               //サーボ1原点
  move_servo(servo_id1, previous_position1, current_position1);
  previous_position1 = current_position1;
 // current_position2 = 400;               //サーボ2原点(ロビ1)
  current_position2 = 250;               //サーボ2原点(ロビ2)
  move_servo(servo_id2, previous_position2, current_position2);
  previous_position2 = current_position2;
  
  rotate_speed = 1000;                  //テストスピード
  current_position1 = -500;               //サーボ1上
  move_servo(servo_id1, previous_position1, current_position1);
  previous_position1 = current_position1;
  current_position1 = 700;               //サーボ1下
  move_servo(servo_id1, previous_position1, current_position1);
  previous_position1 = current_position1;
   current_position1 = 600;               //サーボ1原点
  move_servo(servo_id1, previous_position1, current_position1);
  previous_position1 = current_position1;  
  
  delay(1000);                            //1秒待つ
  //current_position2 = 850;               //サーボ2縮む(ロビ1)
  current_position2 = 700;               //サーボ2縮む(ロビ2)
  move_servo(servo_id2, previous_position2, current_position2);
  previous_position2 = current_position2;
 // current_position2 = -150;               //サーボ2伸ばす(ロビ1)
  current_position2 = -200;               //サーボ2伸ばす(ロビ2)
  move_servo(servo_id2, previous_position2, current_position2);
  previous_position2 = current_position2;
 // current_position2 = 400;               //サーボ2原点(ロビ1)
  current_position2 = 250;               //サーボ2原点(ロビ2)
  move_servo(servo_id2, previous_position2, current_position2);
  previous_position2 = current_position2;
}

void loop() {
}


