
byte servo_id = 255;            //サーボID(特定の番号にする場合は変更)
int rotate_speed = 500;         //1周移動時間(秒×100)
int position_offset = 0;        //全体の位置の調整(+転車台が時計回り、-反時計回り)
int reverse_offset = 0;         //反対周りのオフセット
int current_position = 0;
int previous_position = 1501;     //サーボの以前の位置

byte torque_on_data[] = {0xFA, 0xAF, 0x01, 0x00, 0x24, 0x01, 0x01, 0x01, 0x24}; //トルクONコマンド
byte position_data[] = {0xFA, 0xAF, 0x01, 0x00, 0x1E, 0x04, 0x01, 0x00, 0x00, 0x64, 0x00, 0x7E};  // ポジションコマンド

void memcpy(byte* buf, byte* data, int n)     // データ転送
{
  int sum = 0;
  for(int i = 0; i < n; i++){
    buf[i] = data[i];
  }
}

void checksum(byte* data, int n)     // チェックサムの設定
{
  int sum = 0;
  for(int i = 2; i < n - 1; i++){
    sum = sum ^ data[i];
  }
  data[ n-1 ] = sum;
}

void setup() {
  
  torque_on_data[2] = servo_id;
  position_data[2] = servo_id;
  
  Serial.begin(115200);                 //115200bpsでポートを開く
  delay(500);                            //0.5秒待つ
  checksum(torque_on_data, 9);           //チェックサム計算
  Serial.write(torque_on_data,9);       //サーボトルクON
   delay(500);                            //0.5秒待つlay(500);                          //0.5秒待つ
}

void loop() {  
   if (current_position > 0)
     current_position = -900;
   else
      current_position = 900;
   if (previous_position != current_position) {
    byte data[12];
    int move_position; 
          
   //今回の移動時間を計算
    int move_speed = short(abs((long) previous_position - (long) current_position) * (long) rotate_speed / 3600);
    memcpy(data, position_data, 12);         //回転データ転送
    if (current_position < previous_position) {      
      move_position = current_position + position_offset + reverse_offset;
    }
    else {
      move_position = current_position + position_offset;
    }
    memcpy(data, position_data, 12);         //回転データ転送
    memcpy(&data[7], &move_position, 2);     //変更位置設定
    memcpy(&data[9], &move_speed, 2);        //移動時間設定
    checksum(data, 12);                      //チェックサム計算
    Serial.write(data,12);               //変更位置まで回転
    
    delay(move_speed*10);
      
    previous_position = current_position;    
  }
  delay(100);
}

